
_nostub
_ti92plus

	XDEF	_nostub
	XDEF	_main
;	XDEF	_comment
;	XDEF	_ti89
	XDEF	_ti92plus



SymAddMain	equ	$5D
HeapFree 	equ	$97
HeapRealloc 	equ	$9D
HeapAllocThrow 	equ	$93
HeapDeref 	equ	$96
ST_helpMsg 	equ	$E6
ST_eraseHelp 	equ	$E3
DlgMessage	equ	$1B4
flt		equ	$BD
fmul		equ	$B8
trunc		equ	$BC


ROM_CALL	macro
 		move.l	($C8),a4
		lea	(\1*4)(a4),a4
		move.l	(a4),a4
		jsr	(a4)
		endm



_main:
	bsr	INIT
	bsr	CALC
	bsr	TOKEN1

	tst.b	opt
	beq	esclist
	bsr	TOKEN3
	lea	text2(PC),a0
	move.w	handle2,d3
	bsr	CREATFILE

esclist:
	bsr	TOKEN2
	lea	text1(PC),a0
	move.w	handle1,d3
	bsr	CREATFILE

	bsr	FINAL
	rts



INIT:
	moveq	#0,d1
	moveq	#0,d0
	clr.b	opt
	move.l	($C8),a0
	lea	($109*4)(a0),a0
	move.l	(a0),a0
	move.l	(a0),a0
	cmp.b	#$E5,(a0)
	beq	ERROR
	cmp.b	#$1F,(a0)
	bne	ERROR
	cmp.b	#2,-(a0)
	bhi	ERROR
	bne	inittest1
	move.b	-(a0),d1	
	lsl.w	#8,d1
inittest1:
	move.b	-(a0),d0
	add.w	d0,d1
	cmp.w	#30000,d1
	bhi	ERROR
	cmp.b	#$E5,-(a0)
	beq	inittest2
	cmp.b	#$1F,(a0)
	bne	ERROR
	cmp.b	#1,-(a0)
	bne	ERROR
	cmp.b	#1,-(a0)
	bne	ERROR
	move.b	#1,opt
	cmp.b	#$E5,-(a0)
	bne	ERROR
inittest2:
	move.w	#$700,d0
	Trap	#1
	move.l	d1,ndeci
	lsr.l	#2,d1
	addq.l	#2,d1
	move.l	d1,N
	move.l	d1,d3
	lsl.l	#3,d1
	addq.l	#4,d1
	move.l	d1,-(a7)
	ROM_CALL HeapAllocThrow
;	addq.l	#4,a7
	move.w  d0,handle1
	move.w	d0,-(a7)
	ROM_CALL HeapDeref
;	Addq.l	#2,a7
	lea	address1(PC),a1
	move.l	a0,(a1)+
	lsl.l	#2,d3
	add.l	d3,a0
	move.l	a0,(a1)+
	addq.l	#4,a0
	move.l	a0,(a1)+
	add.l	d3,a0
	move.l	a0,(a1)
	lea	texte(PC),a0
	move.l	a0,-(a7)
	ROM_CALL ST_helpMsg
;	addq.l	#4,a7
	lea	10(a7),a7
	rts


ERROR:
;	addq.l	#4,a7
	clr.l	-(a7)
	lea	help(PC),a0
	move.l	a0,-(a7)
	lea	title(PC),a0
	move.l	a0,-(a7)
	ROM_CALL DlgMessage
;	lea	12(a7),a7
	lea	16(a7),a7
	rts




CALC:
	bsr	FILL1
	lea	numflt1(PC),a0
	lea	add(PC),a2
	moveq	#25,d4
	move.l	#((sum-add)*65536+(sub-add)),d5
	bsr	CALCLOOP
	bsr	FILL2
	bsr	sub
	lea	numflt2(PC),a0
	move.l	#57121,d4
	move.l	#((sub-add)*65536+(sum-add)),d5
	bsr	CALCLOOP
	move.l	address2:4N,a0
	moveq	#4,d0
	bsr	mult
	rts



CALCLOOP:
	link	a6,#-10
	move.l	ndeci,-(a7)
	ROM_CALL flt
	addq.l	#4,a7
	move.l	(a0)+,-(a7)
	move.l	(a0),-(a7)
	move.w	#$3FFF,-(a7)
	ROM_CALL fmul
	lea	10(a7),a7
	ROM_CALL trunc
	unlk	a6
	move.l	d0,d6
	moveq	#1,d0
	move.l	address1,a3
	move.l	address1:4N,a4
	move.l	address2:4N,a5
calcloop1:
	move.w	d5,(a2)
	swap	d5
	move.l	a4,a0
	bsr	mult
	addq.l	#2,d0
	move.l	d0,d3
	bsr	div
	move.l	d4,d3
	bsr	div
	dc.w	%0110000100000000
add:	dc.w	0
  	btst.b	#1,$60001A
	beq	ESC
	dbra	d6,calcloop1
	rts





mult:
	moveq	#0,d2
	move.l	N,d7
	subq.l	#1,d7
multloop:
	move.l	-(a0),d1
	mulu	d0,d1
	add.l	d2,d1
	divu	#10000,d1
	move.w	d1,d2
	swap	d1
	move.w	d1,2(a0)
	dbra	d7,multloop
	rts


div:
	move.l	a3,a0
	move.l	N,d7
	subq.l	#1,d7
divloop:
	move.l	(a0),d1
	divu	d3,d1
	move.l	d1,d2
	and.l	#$FFFF,d2
	move.l	d2,(a0)+
	swap	d1
	and.l	#$FFFF,d1
	mulu	#10000,d1
	add.l	d1,(a0)
	dbra	d7,divloop
	rts


sub:
	move.l	a4,a0
	move.l	a5,a1
	move.l	N,d7
	subq.l	#1,d7
subloop1:
	move.l	-(a0),d1
	move.l	-(a1),d2
	cmp.w	d1,d2
	bge	subloop2
	add.w	#10000,d2
	subq.w	#1,-2(a1)
subloop2:
	sub.w	d1,d2
	move.l	d2,(a1)
	dbra	d7,subloop1
	rts


sum:
	move.l	a4,a0
	move.l	a5,a1
	move.l	N,d7
	subq.l	#1,d7
sumloop:
	move.l	-(a1),d1
	add.l	-(a0),d1
	cmp.w	#10000,d1
	bge	sumtest
	move.l	d1,(a1)
	dbra	d7,sumloop
	rts
sumtest:
	sub.w	#10000,d1
	move.l	d1,(a1)
	addq.w	#1,-2(a1)
	dbra	d7,sumloop
	rts



FILL1:
	move.l	address1,a0
	move.l	N,d0
	lsl.l	#1,d0
	subq.l	#1,d0
	move.l	#8000,(a0)+
Fill1Loop:
	clr.l	(a0)+
	dbra	d0,Fill1Loop
	move.l	address2,a0
	move.l	#8000,(a0)
	rts



FILL2:
	move.l	address1,a0
	clr.w	d1
	move.l	N,d0
Fill2Loop:
	move.l	table(PC,d1.w),(a0)+
	addq.b	#4,d1
	cmp.b	#(7*4),d1
	bne	Fill2Test
	clr.b	d1
Fill2Test:
	dbra	d0,Fill2Loop
	rts

table:	dc.l	0041
	dc.l	8410
	dc.l	0418
	dc.l	4100
	dc.l	4184
	dc.l	1004
	dc.l	1841



ESC:
	addq.l	#8,a7
	move.w  handle1,-(a7)
	ROM_CALL HeapFree
	addq.l	#2,a7
	ROM_CALL ST_eraseHelp
	moveq	#0,d0
	Trap	#1
	rts



TOKEN1:
	move.l	address2:4N,a0
	move.l	N,d3
	subq.l	#1,d3
Tok1Loop1:
	move.l	-4(a0),d0
	moveq	#3,d2
Tok1Loop2:
	divu	#10,d0
	move.l	d0,d1
	swap	d1
	move.b	d1,-(a0)
	and.l	#$FFFF,d0
	dbra	d2,Tok1Loop2
	dbra	d3,Tok1Loop1
	rts



TOKEN2:
	move.l	address1,a1
	move.l	address2,a2
	addq.l	#2,a1
	move.w	#0001,(a1)+
	move.l	#$20332C0D,(a1)+
	move.l	ndeci,d0
	divu	#25,d0
	move.l	d0,d1
	swap	d1
	and.l	#$FFFF,d1
	tst.w	d0
	beq	EndTok1
	subq.l	#1,d0
Tok2Loop1:
	move.b	#$20,(a1)+
	moveq	#24,d3
Tok2Loop2:
	move.b	(a2)+,(a1)
	add.b	#48,(a1)+
	dbra	d3,Tok2Loop2
	move.b	#$0D,(a1)+
	dbra	d0,Tok2Loop1
	tst.w	d1
	beq	Tok2Test
EndTok1:
	move.b	#$20,(a1)+
	tst.w	d1
	beq	EndTok2
	subq.l	#1,d1
Tok2Loop3:
	move.b	(a2)+,(a1)
	add.b	#48,(a1)+
	dbra	d1,Tok2Loop3
EndTok2:
	clr.b	(a1)+
	move.b	#$E0,(a1)
	move.l	address1,a2
	subq.l	#1,a1
	sub.l	a2,a1
	move.w	a1,(a2)
	bra	Realloc
Tok2Test:
	subq.l	#1,a1
	bra	EndTok2

Realloc:
	moveq	#0,d0
	move.w	(a2),d0
	addq.w	#2,d0
	move.l	d0,-(a7)
	move.w  handle1,-(a7)
	ROM_CALL HeapRealloc
	addq.l	#6,a7
	rts



TOKEN3:
	move.l	ndeci(PC),d0
	move.l	d0,d3
	mulu	#3,d0
	addq.l	#4,d0
	move.l	d0,-(a7)
	ROM_CALL HeapAllocThrow
	addq.l	#4,a7
	move.w	d0,handle2
	move.w	d0,-(a7)
	ROM_CALL HeapDeref
	Addq.l	#2,a7
	move.l	a0,a3
	move.l	address2(PC),a2
	addq.l	#2,a0
	add.l	d3,a2
	subq.l	#1,d3
	move.b	#$E5,(a0)+
Tok3Loop:
	move.b	-(a2),(a0)+
	move.b	#$01,(a0)+
	move.b	#$1F,(a0)+
	dbra	d3,Tok3Loop
	move.b	#$D9,(a0)
	subq.l	#1,a0
	sub.l	a3,a0
	move.w	a0,(a3)
	rts



CREATFILE:
	move.l	a0,-(a7)
	ROM_CALL SymAddMain
	addq.l	#4,a7
	move.w	d0,d1
	swap	d0
	move.w	d0,-(a7)
	ROM_CALL HeapDeref
	addq.l	#2,a7
	move.w	d3,12(a0,d1.w)
	rts


FINAL:
	lea	fin(PC),a0
	move.l	a0,-(a7)
	ROM_CALL ST_helpMsg
	addq.l	#4,a7
	moveq	#0,d0
	Trap	#1
	rts




;_comment:	dc.b	"Pi Dcimales par AST",0
texte		dc.b	"Calcul en cours...(ON=ESC)",0
fin		dc.b	"Rsultat dans 'pitext.text'"
		dc.b	", ['pilist.list']"
		dc.b	"   (ast2000@wanadoo.fr)",0
help		dc.b	"Pi(n,[1]):  1 < n < 30000 !",0
title		dc.b	"ERREUR",0
opt		dc.b	0
address1	dc.l	0
address1:4N	dc.l	0
address2	dc.l	0
address2:4N	dc.l	0
ndeci		dc.l	0
N		dc.l	0
numflt1		dc.l	$61340000,$71503767
numflt2		dc.l	$77260000,$21256247
handle1		dc.w	0
handle2		dc.w	0
		dc.b	0,"pitext"
text1		dc.b	0
		dc.b	0,"pilist"
text2		dc.b	0

	END
